//
// ContentView.swift
//
// Created by Wesley de Groot
// https://wesleydegroot.nl
//

import SwiftUI

struct ContentView: View {
    var body: some View {
        VStack {
            Text("Hello Example, see code below")
        }
        .task {
             testCode()
        }
    }
    
    func testCode() {        
        let result = Result {
            try Data(
                contentsOf: URL(
                    // To test failure, put a random character
                    // somewhere in "https".
                    string: "https://wesleydegroot.nl/robots.txt"
                )!
            )
        }
        
        switch result {
        case .success(let data):
            // Do something with the data
            print("Switch Data:", data)
        case .failure(let error):
            // Handle the error
            print("Switch Error:", error)
        }
        
        
        if case let .failure(error) = result {
            print(".failure(error) = result", error)
        }
        
        if case .failure(let error) = result {
            print(".failure(let error) = result", error)
        }
        
        if case let .success(data) = result, data.count > 100 {
            print(".success(data) = result, data.count > 100")
        }
        
        // Using an if statement
        if case let .success(data) = result {
            print(".success(data) = result", data)
        }
        
        // Using an alternate form
        if case .success(let data) = result {
            print(".success(let data) = result", data)
        }
    }
}
